
Core - Bug # 66671

Status: Closed Priority: Should have
Author: Xavier Perseguers Category: DBAL
Created: 2015-04-30 Assigned To:
Updated: 2015-06-18 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: hard
Is Regression: No
Sprint Focus:
Subject: Install Tool should show the ALTER TABLE instead of CREATE TABLE
Description

In TYPO3 4.5 many tables where not fully "conform" with the ext_tables.sql definition (various minor mixup due to other field types)
but having the ALTER TABLE statements helped to know whether one had to worry about it or not.

In TYPO3 6.2 only the CREATE TABLE statement is shown and it is

    -  hard to know what is missing (full table, only a few fields, only mixup in field types)

Related issues:
related to Core - Bug # 66691: Cannot clear all cache in Install Tool Needs Feedback2015-04-30
related to Core - Bug # 67286: InstallTool Database Compare shows all tables ... Resolved 2015-06-03

History
#1 - 2015-04-30 10:49 - Xavier Perseguers

Hint: when checking a single CREATE TABLE statement in Install Tool which then succeeds, the result screen properly shows a list of additional
ALTER TABLE statements that should be executed.

#2 - 2015-05-07 15:00 - Xavier Perseguers
- Complexity set to hard

OK, analyze:

We miss a call to ->sql_pconnect() or ->connectDB() in Install Tool somehow because this call will properly instantiate the ->handlerInstance and thus
lead to have the _DEFAULT instance uninitialized.

This missing call is originating from

    -  \TYPO3\CMS\Core\Core\Bootstrap::initializeTypo3DbGlobal() which is called from
    -  \TYPO3\CMS\Install\Controller\Action\AbstractAction::loadExtLocalconfDatabaseAndExtTables()

Now, within DBAL's method sql_select_db(), we miss the check of ->isConnected() at the beginning, something that we have when using Core's
overridden method.

If we add the call:

if (!$this->isConnected()) {
    $this->connectDB();
}

we have a recursion to ->sql_select_db() because \TYPO3\CMS\Dbal\Database\DatabaseConnection::isConnected() returns FALSE since 
$this->lastHandlerKey is still to its default (empty) value (see class definition).

BUT, if we set the default value to "_DEFAULT", this fixes the bug, if we are already in the main windows of the Install Tool (initial steps have passed)
but it crashes the Install Tool with:

TYPO3 Fatal Error: No database selected!

when opening the Install Tool for the first time, e.g., by clicking the corresponding module in TYPO3 Backend.

This is caused by \TYPO3\CMS\Dbal\Database\DatabaseConnection::handler_init() not fully initializing $this->handlerCfg[$handlerKey] (beginning of
the method). More specifically the 'type' is still set to "native", which only works if DBAL is configured with a 'mysqli' backend, so not in a real use of
DBAL (e.g., with MSSQL).

This in turn, happens because prior to the change, DBAL's sql_select_db() did not call ->connectDB(). But not having this call causes another bug in
Install Tool, namely that opening http://mywebsite/typo3/install always blocks on the database selection (call to getDatabaseList() which calls 
->admin_get_dbs(), again as "native" driver has not been replaced. Only (current) way is to manually trick the URL to go to the Tool controller.

Dirty hack
Merge "type" and "driverOptions" when initializing ->handlerCfg['__DEFAULT'] from $this->conf when $this->databaseName is not empty:

$this->handlerCfg[$handlerKey]['type'] = $this->conf['handlerCfg'][$handlerKey]['type'];
// same for driverOptions

#3 - 2015-06-15 13:51 - Morton Jonuschat

I think this has been solved in #67286

#4 - 2015-06-15 13:51 - Morton Jonuschat
- Status changed from New to Needs Feedback

#5 - 2015-06-15 13:59 - Tizian Schmidlin

I can confirm that this looks like the solution!

Thanks Morton!

#6 - 2015-06-18 11:42 - Alexander Opitz
- Status changed from Needs Feedback to Closed

Thanks for your feedback.
